
/**
 * Ein Objekt der Klasse TGUI ist zustndig fr die Erzeugung und
 * Aktivierung smtlicher am Chuck-A-Luck-Spiel beteiligter Objekte und
 * auch fr die Anzeige der Spielergebnisse.
 *
 * @author K. Becker 
 * @version 22.12.05
 */

public class TGUI
{
  private
    TWuerfel wuerfelA, wuerfelB, wuerfelC;
    TKonto konto;
    TSpielbrett spielbrett;
    TSpielmanager spielmanager;
  
  /**
   * Erzeuge ein Objekt der Klasse TGUI.
   */
  TGUI()
  {
    wuerfelA = new TWuerfel();
    wuerfelB = new TWuerfel();
    wuerfelC = new TWuerfel();
    konto = new TKonto(100);
    spielbrett = new TSpielbrett();
    spielmanager = new TSpielmanager
                         (spielbrett, wuerfelA, wuerfelB, wuerfelC, konto);
  }

  /**
   * Aktiviere das Spiel und zeige die Ergebnisse an.
   */
  void spielDatenAnzeigen()
  {
    System.out.println("Spielbrett : " + spielbrett.getZahl());
    System.out.println("Wuerfel A  : " + wuerfelA.getAugen());
    System.out.println("Wuerfel B  : " + wuerfelB.getAugen());
    System.out.println("Wuerfel C  : " + wuerfelC.getAugen());
    System.out.println("Konto      : " + konto.getStand());
    System.out.println();
  }

  void BEinsatzZahlenClick()
  {
    spielmanager.einsatzZahlen();
  }

  void RGSpielbrettClick(int tipp)
  {
    spielmanager.spielzahlSetzen(tipp);
  }

  void BWuerfelWerfenClick()
  {
    spielmanager.wuerfelWerfen();
  }
  
  void BGewinnVerbuchenClick()
  {
    spielmanager.gewinnVerbuchen();
  }


}
