
/**
 * Ein Objekt der Klasse TSpielmanager ist zustndig fr die Erzeugung der
 * beteiligten Objekte und zur Durchfhrung eines geordneten Spielablaufs.
 *
 * @author K. Becker 
 * @version 22.12.05
 */

public class TSpielmanager
{
  private
    TWuerfel wuerfelA, wuerfelB, wuerfelC;
    TKonto konto;
    TSpielbrett spielbrett;

  /**
   * Erzeuge ein Objekt der Klasse TSpielmanager
   */
  public TSpielmanager
           (TSpielbrett sb, TWuerfel wA, TWuerfel wB, TWuerfel wC, TKonto k)
  {
    spielbrett = sb;
    wuerfelA = wA;
    wuerfelB = wB;
    wuerfelC = wC;
    konto = k;
  }

  /**
   * Zahle den Einsatz fr ein Spiel.
   */
  public void einsatzZahlen()
  {
    konto.abheben(1);   
  }

  /**
   * Lege die Spielzahl auf dem Spielbrett fest.
   */
  public void spielzahlSetzen(int z)
  {
    spielbrett.setzen(z);
  }


  /**
   * Werfe die drei Wrfel.
   */
  public void wuerfelWerfen()
  {
    wuerfelA.werfen();
    wuerfelB.werfen();
    wuerfelC.werfen();
  }

  /**
   * Werte das Spiel aus und verbuche ggf. den Gewinn auf dem Konto.
   */
  public void gewinnVerbuchen()
  {
    int gewinn = 0;
    if (spielbrett.zahl == wuerfelA.augen)
      gewinn = gewinn + 1;
    if (spielbrett.zahl == wuerfelB.augen)
      gewinn = gewinn + 1;
    if (spielbrett.zahl == wuerfelC.augen)
      gewinn = gewinn + 1;
    if (gewinn > 0)
      konto.einzahlen(gewinn + 1);
  }

  public int getWuerfelA()
  {
    return wuerfelA.getAugen();
  }

  public int getWuerfelB()
  {
    return wuerfelB.getAugen();
  }
  
  public int getWuerfelC()
  {
    return wuerfelC.getAugen();
  }
  
  public int getKonto()
  {
    return konto.getStand();
  }
  
  public int getSpielzahl()
  {
    return spielbrett.getZahl();
  }


  
}
