unit uCodierung;

interface

type
  TCodierung = class
  private
    code: array ['A'..'Z'] of char;
  public
    constructor create;
    procedure setCode(s: string);
    function getCode: string;
    function getGeheim(klar: char): char;
    function getKlar(geheim: char): char;
  end;

implementation

constructor TCodierung.create;
  var c: char;
begin
  for c := 'A' to 'Z' do
    code[c] := '*';
end;

procedure TCodierung.setCode(s: string);
  var c, d, h: char;
      i: integer;
      check: array ['A'..'Z'] of boolean;

begin
  for c := 'A' to 'Z' do
    check[c] := false;
  i := 1;
  d := 'A';
  while i <= length(s) do
  begin
    h := s[i];
    if check[h] = false then
    begin
      code[d] := h;
      check[h] := true;
      d := succ(d);
    end;
    i := succ(i);
  end;
  for c := h to 'Z' do
    if check[c] = false then
    begin
      code[d] := c;
      d := succ(d);
    end;
  for c := 'A' to h do
    if check[c] = false then
    begin
      code[d] := c;
      d := succ(d);
    end;
end;

function TCodierung.getCode: string;
  var hilf: string;
      c: char;
begin
  hilf := '';
  for c := 'A' to 'Z' do
    hilf := hilf + code[c];
  result := hilf;
end;

function TCodierung.getGeheim(klar: char): char;
begin
  result := code[klar];
end;

function TCodierung.getKlar(geheim: char): char;
  var c, h: char;
begin
  h := '*';
  for c := 'A' to 'Z' do
    if code[c] = geheim then h := c;
  result := h;
end;

end.
