unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uWuerfel, uSpielbrett, uKonto, uSpielmanager, jpeg;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBWuerfel: TGroupBox;
    GBKonto: TGroupBox;
    PKonto: TPanel;
    RGSpielbrett: TRadioGroup;
    BGewinnVerbuchen: TButton;
    BWuerfelWerfen: TButton;
    BEinsatzZahlen: TButton;
    ImageA: TImage;
    ImageB: TImage;
    ImageC: TImage;
    procedure FormCreate(Sender: TObject);
    procedure RGSpielbrettClick(Sender: TObject);
    procedure BGewinnVerbuchenClick(Sender: TObject);
    procedure BWuerfelWerfenClick(Sender: TObject);
    procedure BEinsatzZahlenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    wuerfelA, wuerfelB, wuerfelC: TWuerfel;
    spielbrett: TSpielbrett;
    konto: TKonto;
    spielmanager: TSpielmanager;
    procedure wuerfelAnzeigen(wuerfel: TWuerfel; image: TImage);
  public
    procedure spielDatenAnzeigen;
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;


implementation

{$R *.DFM}

procedure TGUI.wuerfelAnzeigen(wuerfel: TWuerfel; image: TImage);
begin
  case wuerfel.getAugen of
    1: image.Picture.LoadFromFile('wuerfel1.jpg');
    2: image.Picture.LoadFromFile('wuerfel2.jpg');
    3: image.Picture.LoadFromFile('wuerfel3.jpg');
    4: image.Picture.LoadFromFile('wuerfel4.jpg');
    5: image.Picture.LoadFromFile('wuerfel5.jpg');
    6: image.Picture.LoadFromFile('wuerfel6.jpg');
  end;
end;

procedure TGUI.spielDatenAnzeigen;
begin
  PKonto.Caption := IntToStr(konto.getStand);
  wuerfelAnzeigen(wuerfelA, ImageA);
  wuerfelAnzeigen(wuerfelB, ImageB);
  wuerfelAnzeigen(wuerfelC, ImageC);
end;

procedure TGUI.FormCreate(Sender: TObject);
begin
  randomize;
  spielbrett := TSpielbrett.create;
  wuerfelA := TWuerfel.create;
  wuerfelB := TWuerfel.create;
  wuerfelC := TWuerfel.create;
  konto := TKonto.create(100);
  spielmanager := TSpielmanager.create
                  (spielbrett, wuerfelA, wuerfelB, wuerfelC, konto);
  spielDatenAnzeigen;
  RGSpielbrett.Enabled := false;
end;

procedure TGUI.RGSpielbrettClick(Sender: TObject);
  var tipp: integer;
begin
  tipp := RGSpielbrett.ItemIndex+1;
  spielmanager.spielzahlSetzen(tipp);
end;

procedure TGUI.BGewinnVerbuchenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.gewinnVerbuchen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen
end;

procedure TGUI.BWuerfelWerfenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.wuerfelWerfen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
end;

procedure TGUI.BEinsatzZahlenClick(Sender: TObject);
begin
  // Aktualisierung des Modells
  spielmanager.einsatzZahlen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
  if spielmanager.getZustand = 1 then RGSpielbrett.Enabled := true;
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  spielbrett.free;
  konto.free;
  wuerfelC.free;
  wuerfelB.free;
  wuerfelA.free;
  spielmanager.free;
end;

end.
