unit uSpielmanager;

interface

uses uWuerfel, uKonto, uSpielbrett;

type
  TSpielmanager = class
  private
    zustand: integer;
    wuerfelA: TWuerfel;
    wuerfelB: TWuerfel;
    wuerfelC: TWuerfel;
    konto: TKonto;
    spielbrett: TSpielbrett;
  public
    constructor create(sb: TSpielbrett; wA, wB, wC: TWuerfel; k: TKonto);
    procedure einsatzZahlen;
    procedure spielzahlSetzen(z: integer);
    procedure wuerfelWerfen;
    procedure gewinnVerbuchen;
    function getZustand: integer;
  end;

implementation

constructor TSpielmanager.create
              (sb: TSpielbrett; wA, wB, wC: TWuerfel; k: TKonto);
begin
  zustand := 0;
  wuerfelA := wA;
  wuerfelB := wB;
  wuerfelC := wC;
  konto := k;
  spielbrett := sb;
end;

procedure TSpielmanager.einsatzZahlen;
begin
  if zustand = 0 then
  begin
    konto.abheben(2);
    zustand := 1;
  end;
end;

procedure TSpielmanager.spielzahlSetzen(z: integer);
begin
  if zustand = 1 then
  begin
    spielbrett.setzen(z);
    zustand := 1;
  end;
end;

procedure TSpielmanager.wuerfelWerfen;
begin
  if zustand = 1 then
  begin
    wuerfelA.werfen;
    wuerfelB.werfen;
    wuerfelC.werfen;
    zustand := 2;
  end;
end;

procedure TSpielmanager.gewinnVerbuchen;
  var richtige, zahl: integer;
begin
  if zustand = 2 then
  begin
    richtige := 0;
    zahl := spielbrett.getZahl;
    if zahl = wuerfelA.getAugen then inc(richtige);
    if zahl = wuerfelB.getAugen then inc(richtige);
    if zahl = wuerfelC.getAugen then inc(richtige);
    if richtige > 0 then konto.einzahlen(3*richtige);
    zustand := 0;
  end;
end;

function TSpielmanager.getZustand: integer;
begin
  result := zustand;
end;

end.
