unit uWelt;

interface

type
  TWelt = class
  private
    marken: array [0..9] of array [0..9] of boolean;
    ziegel: array [0..9] of array [0..9] of integer;
  public
    constructor create;
    procedure markeSetzen(x, y: integer);
    procedure markeLoeschen(x, y: integer);
    procedure ziegelHinlegen(x, y: integer);
    procedure ziegelAufheben(x, y: integer);
    function getMarke(x, y: integer): boolean;
    function getZiegel(x, y: integer): integer;
  end;

implementation

constructor TWelt.create;
  var i, j: integer;
begin
  for i := 0 to 9 do
    for j := 0 to 9 do
    begin
      marken[i][j] := false;
      ziegel[i][j] := 0;
    end
end;

procedure TWelt.markeSetzen(x, y: integer);
begin
  marken[x][y] := true;
end;

procedure TWelt.markeLoeschen(x, y: integer);
begin
  marken[x][y] := false;
end;

procedure TWelt.ziegelHinlegen(x, y: integer);
begin
  inc(ziegel[x][y]);
end;

procedure TWelt.ziegelAufheben(x, y: integer);
begin
  if ziegel[x][y] > 0 then dec(ziegel[x][y]);
end;

function TWelt.getMarke(x, y: integer): boolean;
begin
  result := marken[x][y];
end;

function TWelt.getZiegel(x, y: integer): integer;
begin
  result := ziegel[x][y];
end;

end.


