unit uRoboter;

interface

uses uWelt;

type
  tRichtung = (sueden, westen, norden, osten);

type
  TRoboter = class
  private
    xpos: integer;
    ypos: integer;
    richtung: tRichtung;
    welt: TWelt;
  public
    constructor create(w: TWelt);
    procedure initialisieren;
    procedure schritt;
    procedure rechtsDrehen;
    procedure linksDrehen;
    procedure markeSetzen;
    procedure markeLoeschen;
    procedure ziegelHinlegen;
    procedure ziegelAufheben;
    function getXpos: integer;
    function getYpos: integer;
    function getRichtung: tRichtung;
  end;

implementation

constructor TRoboter.create(w: TWelt);
begin
  welt := w;
  initialisieren;
end;

procedure TRoboter.initialisieren;
begin
  xPos := 0;
  yPos := 0;
  richtung := sueden;
end;

procedure TRoboter.schritt;
begin
  case richtung of
    sueden: if yPos < welt.getYMax then yPos := yPos + 1;
    westen: if xPos > 0 then xPos := xPos - 1;
    norden: if yPos > 0 then yPos := yPos - 1;
    osten : if xPos < welt.getXMax then xPos := xPos + 1;
  end;
end;

procedure TRoboter.rechtsDrehen;
begin
  case richtung of
    sueden: richtung := westen;
    westen: richtung := norden;
    norden: richtung := osten;
    osten : richtung := sueden;
  end;
end;

procedure TRoboter.linksDrehen;
begin
  case richtung of
    sueden: richtung := osten;
    westen: richtung := sueden;
    norden: richtung := westen;
    osten : richtung := norden;
  end;
end;

procedure TRoboter.markeSetzen;
begin
  welt.markeSetzen(xPos, yPos);
end;

procedure TRoboter.markeLoeschen;
begin
  welt.markeLoeschen(xPos, yPos);
end;

procedure TRoboter.ziegelHinlegen;
begin
  welt.ziegelHinlegen(xPos, yPos);
end;

procedure TRoboter.ziegelAufheben;
begin
  welt.ziegelAufheben(xPos, yPos);
end;

function TRoboter.getXpos: integer;
begin
  result := xPos;
end;

function TRoboter.getYpos: integer;
begin
  result := yPos;
end;

function TRoboter.getRichtung: tRichtung;
begin
  result := richtung;
end;

end.
