unit uWelt;

interface

type
  TWelt = class
  private
    xMax: integer;
    yMax: integer;
    marken: array of array of boolean;
    ziegel: array of array of integer;
  public
    constructor create(laenge, breite: integer);
    procedure markeSetzen(x, y: integer);
    procedure markeLoeschen(x, y: integer);

    procedure ziegelHinlegen(x, y: integer);
    procedure ziegelAufheben(x, y: integer);

    function getxMax: integer;
    function getyMax: integer;
    function getMarke(x, y: integer): boolean;
    function getZiegel(x, y: integer): integer;
  end;

implementation

constructor TWelt.create(laenge, breite: integer);
  var i, j: integer;
begin
  xMax := laenge-1;
  yMax := breite-1;
  SetLength(marken, xMax+1);
  for i := Low(marken) to High(marken) do
    SetLength(marken[i], yMax+1);
  SetLength(ziegel, xMax+1);
  for i := Low(ziegel) to High(ziegel) do
    SetLength(ziegel[i], yMax+1);
  for i := 0 to xMax do
    for j := 0 to yMax do
      marken[i][j] := false;
  for i := 0 to xMax do
    for j := 0 to yMax do
      ziegel[i][j] := 0;
end;

procedure TWelt.markeSetzen(x, y: integer);
begin
  marken[x][y] := true;
end;

procedure TWelt.markeLoeschen(x, y: integer);
begin
  marken[x][y] := false;
end;

procedure TWelt.ziegelHinlegen(x, y: integer);
begin
  inc(ziegel[x][y]);
end;

procedure TWelt.ziegelAufheben(x, y: integer);
begin
  if ziegel[x][y] > 0 then dec(ziegel[x][y]);
end;

function TWelt.getxMax: integer;
begin
  result := xMax;
end;

function TWelt.getyMax: integer;
begin
  result := yMax;
end;

function TWelt.getMarke(x, y: integer): boolean;
begin
  result := marken[x][y];
end;

function TWelt.getZiegel(x, y: integer): integer;
begin
  result := ziegel[x][y];
end;

end.

